/// The mapping rules updated in 2021/09
const Map<String, String> mapping = {
  // 臺北市
  '100': '臺北市中正區',
  '103': '臺北市大同區',
  '104': '臺北市中山區',
  '105': '臺北市松山區',
  '106': '臺北市大安區',
  '108': '臺北市萬華區',
  '110': '臺北市信義區',
  '111': '臺北市士林區',
  '112': '臺北市北投區',
  '114': '臺北市內湖區',
  '115': '臺北市南港區',
  '116': '臺北市文山區',
  // 基隆市
  '200': '基隆市仁愛區',
  '201': '基隆市信義區',
  '202': '基隆市中正區',
  '203': '基隆市中山區',
  '204': '基隆市安樂區',
  '205': '基隆市暖暖區',
  '206': '基隆市七堵區',
  // 連江縣
  '209': '連江縣南竿鄉',
  '210': '連江縣北竿鄉',
  '211': '連江縣莒光鄉',
  '212': '連江縣東引鄉',
  // 新北市
  '207': '新北市萬里區',
  '208': '新北市金山區',
  '220': '新北市板橋區',
  '221': '新北市汐止區',
  '222': '新北市深坑區',
  '223': '新北市石碇區',
  '224': '新北市瑞芳區',
  '226': '新北市平溪區',
  '227': '新北市雙溪區',
  '228': '新北市貢寮區',
  '231': '新北市新店區',
  '232': '新北市坪林區',
  '233': '新北市烏來區',
  '234': '新北市永和區',
  '235': '新北市中和區',
  '236': '新北市土城區',
  '237': '新北市三峽區',
  '238': '新北市樹林區',
  '239': '新北市鶯歌區',
  '241': '新北市三重區',
  '242': '新北市新莊區',
  '243': '新北市泰山區',
  '244': '新北市林口區',
  '247': '新北市蘆洲區',
  '248': '新北市五股區',
  '249': '新北市八里區',
  '251': '新北市淡水區',
  '252': '新北市三芝區',
  '253': '新北市石門區',
  // 宜蘭縣
  '260': '宜蘭縣宜蘭市',
  '261': '宜蘭縣頭城鎮',
  '262': '宜蘭縣礁溪鄉',
  '263': '宜蘭縣壯圍鄉',
  '264': '宜蘭縣員山鄉',
  '265': '宜蘭縣羅東鎮',
  '266': '宜蘭縣三星鄉',
  '267': '宜蘭縣大同鄉',
  '268': '宜蘭縣五結鄉',
  '269': '宜蘭縣冬山鄉',
  '270': '宜蘭縣蘇澳鎮',
  '272': '宜蘭縣南澳鄉',
  '290': '釣魚臺釣魚臺',
  // 新竹市
  '300N': '新竹市北區',
  '300E': '新竹市東區',
  '300H': '新竹市香山區',
  // 新竹縣
  '302': '新竹縣竹北市',
  '303': '新竹縣湖口鄉',
  '304': '新竹縣新豐鄉',
  '305': '新竹縣新埔鎮',
  '306': '新竹縣關西鎮',
  '307': '新竹縣芎林鄉',
  '308': '新竹縣寶山鄉',
  '310': '新竹縣竹東鎮',
  '311': '新竹縣五峰鄉',
  '312': '新竹縣橫山鄉',
  '313': '新竹縣尖石鄉',
  '314': '新竹縣北埔鄉',
  '315': '新竹縣峨眉鄉',
  // 桃園市
  '320': '桃園市中壢區',
  '324': '桃園市平鎮區',
  '325': '桃園市龍潭區',
  '326': '桃園市楊梅區',
  '327': '桃園市新屋區',
  '328': '桃園市觀音區',
  '330': '桃園市桃園區',
  '333': '桃園市龜山區',
  '334': '桃園市八德區',
  '335': '桃園市大溪區',
  '336': '桃園市復興區',
  '337': '桃園市大園區',
  '338': '桃園市蘆竹區',
  // 苗栗縣
  '350': '苗栗縣竹南鎮',
  '351': '苗栗縣頭份市',
  '352': '苗栗縣三灣鄉',
  '353': '苗栗縣南庄鄉',
  '354': '苗栗縣獅潭鄉',
  '356': '苗栗縣後龍鎮',
  '357': '苗栗縣通霄鎮',
  '358': '苗栗縣苑裡鎮',
  '360': '苗栗縣苗栗市',
  '361': '苗栗縣造橋鄉',
  '362': '苗栗縣頭屋鄉',
  '363': '苗栗縣公館鄉',
  '364': '苗栗縣大湖鄉',
  '365': '苗栗縣泰安鄉',
  '366': '苗栗縣銅鑼鄉',
  '367': '苗栗縣三義鄉',
  '368': '苗栗縣西湖鄉',
  '369': '苗栗縣卓蘭鎮',
  // 臺中市
  '400': '臺中市中區',
  '401': '臺中市東區',
  '402': '臺中市南區',
  '403': '臺中市西區',
  '404': '臺中市北區',
  '406': '臺中市北屯區',
  '407': '臺中市西屯區',
  '408': '臺中市南屯區',
  '411': '臺中市太平區',
  '412': '臺中市大里區',
  '413': '臺中市霧峰區',
  '414': '臺中市烏日區',
  '420': '臺中市豐原區',
  '421': '臺中市后里區',
  '422': '臺中市石岡區',
  '423': '臺中市東勢區',
  '424': '臺中市和平區',
  '426': '臺中市新社區',
  '427': '臺中市潭子區',
  '428': '臺中市大雅區',
  '429': '臺中市神岡區',
  '432': '臺中市大肚區',
  '433': '臺中市沙鹿區',
  '434': '臺中市龍井區',
  '435': '臺中市梧棲區',
  '436': '臺中市清水區',
  '437': '臺中市大甲區',
  '438': '臺中市外埔區',
  '439': '臺中市大安區',
  // 彰化縣
  '500': '彰化縣彰化市',
  '502': '彰化縣芬園鄉',
  '503': '彰化縣花壇鄉',
  '504': '彰化縣秀水鄉',
  '505': '彰化縣鹿港鎮',
  '506': '彰化縣福興鄉',
  '507': '彰化縣線西鄉',
  '508': '彰化縣和美鎮',
  '509': '彰化縣伸港鄉',
  '510': '彰化縣員林市',
  '511': '彰化縣社頭鄉',
  '512': '彰化縣永靖鄉',
  '513': '彰化縣埔心鄉',
  '514': '彰化縣溪湖鎮',
  '515': '彰化縣大村鄉',
  '516': '彰化縣埔鹽鄉',
  '520': '彰化縣田中鎮',
  '521': '彰化縣北斗鎮',
  '522': '彰化縣田尾鄉',
  '523': '彰化縣埤頭鄉',
  '524': '彰化縣溪州鄉',
  '525': '彰化縣竹塘鄉',
  '526': '彰化縣二林鎮',
  '527': '彰化縣大城鄉',
  '528': '彰化縣芳苑鄉',
  '530': '彰化縣二水鄉',
  // 南投縣
  '540': '南投縣南投市',
  '541': '南投縣中寮鄉',
  '542': '南投縣草屯鎮',
  '544': '南投縣國姓鄉',
  '545': '南投縣埔里鎮',
  '546': '南投縣仁愛鄉',
  '551': '南投縣名間鄉',
  '552': '南投縣集集鎮',
  '553': '南投縣水里鄉',
  '555': '南投縣魚池鄉',
  '556': '南投縣信義鄉',
  '557': '南投縣竹山鎮',
  '558': '南投縣鹿谷鄉',
  // 嘉義市
  '600E': '嘉義市東區',
  '600W': '嘉義市西區',
  // 嘉義縣
  '602': '嘉義縣番路鄉',
  '603': '嘉義縣梅山鄉',
  '604': '嘉義縣竹崎鄉',
  '605': '嘉義縣阿里山鄉',
  '606': '嘉義縣中埔鄉',
  '607': '嘉義縣大埔鄉',
  '608': '嘉義縣水上鄉',
  '611': '嘉義縣鹿草鄉',
  '612': '嘉義縣太保市',
  '613': '嘉義縣朴子市',
  '614': '嘉義縣東石鄉',
  '615': '嘉義縣六腳鄉',
  '616': '嘉義縣新港鄉',
  '621': '嘉義縣民雄鄉',
  '622': '嘉義縣大林鎮',
  '623': '嘉義縣溪口鄉',
  '624': '嘉義縣義竹鄉',
  '625': '嘉義縣布袋鎮',
  // 雲林縣
  '630': '雲林縣斗南鎮',
  '631': '雲林縣大埤鄉',
  '632': '雲林縣虎尾鎮',
  '633': '雲林縣土庫鎮',
  '634': '雲林縣褒忠鄉',
  '635': '雲林縣東勢鄉',
  '636': '雲林縣臺西鄉',
  '637': '雲林縣崙背鄉',
  '638': '雲林縣麥寮鄉',
  '640': '雲林縣斗六市',
  '643': '雲林縣林內鄉',
  '646': '雲林縣古坑鄉',
  '647': '雲林縣莿桐鄉',
  '648': '雲林縣西螺鎮',
  '649': '雲林縣二崙鄉',
  '651': '雲林縣北港鎮',
  '652': '雲林縣水林鄉',
  '653': '雲林縣口湖鄉',
  '654': '雲林縣四湖鄉',
  '655': '雲林縣元長鄉',
  // 臺南市
  '700': '臺南市中西區',
  '701': '臺南市東區',
  '702': '臺南市南區',
  '704': '臺南市北區',
  '708': '臺南市安平區',
  '709': '臺南市安南區',
  '710': '臺南市永康區',
  '711': '臺南市歸仁區',
  '712': '臺南市新化區',
  '713': '臺南市左鎮區',
  '714': '臺南市玉井區',
  '715': '臺南市楠西區',
  '716': '臺南市南化區',
  '717': '臺南市仁德區',
  '718': '臺南市關廟區',
  '719': '臺南市龍崎區',
  '720': '臺南市官田區',
  '721': '臺南市麻豆區',
  '722': '臺南市佳里區',
  '723': '臺南市西港區',
  '724': '臺南市七股區',
  '725': '臺南市將軍區',
  '726': '臺南市學甲區',
  '727': '臺南市北門區',
  '730': '臺南市新營區',
  '731': '臺南市後壁區',
  '732': '臺南市白河區',
  '733': '臺南市東山區',
  '734': '臺南市六甲區',
  '735': '臺南市下營區',
  '736': '臺南市柳營區',
  '737': '臺南市鹽水區',
  '741': '臺南市善化區',
  '742': '臺南市大內區',
  '743': '臺南市山上區',
  '744': '臺南市新市區',
  '745': '臺南市安定區',
  // 高雄市
  '800': '高雄市新興區',
  '801': '高雄市前金區',
  '802': '高雄市苓雅區',
  '803': '高雄市鹽埕區',
  '804': '高雄市鼓山區',
  '805': '高雄市旗津區',
  '806': '高雄市前鎮區',
  '807': '高雄市三民區',
  '811': '高雄市楠梓區',
  '812': '高雄市小港區',
  '813': '高雄市左營區',
  '814': '高雄市仁武區',
  '815': '高雄市大社區',
  '820': '高雄市岡山區',
  '821': '高雄市路竹區',
  '822': '高雄市阿蓮區',
  '823': '高雄市田寮區',
  '824': '高雄市燕巢區',
  '825': '高雄市橋頭區',
  '826': '高雄市梓官區',
  '827': '高雄市彌陀區',
  '828': '高雄市永安區',
  '829': '高雄市湖內區',
  '830': '高雄市鳳山區',
  '831': '高雄市大寮區',
  '832': '高雄市林園區',
  '833': '高雄市鳥松區',
  '840': '高雄市大樹區',
  '842': '高雄市旗山區',
  '843': '高雄市美濃區',
  '844': '高雄市六龜區',
  '845': '高雄市內門區',
  '846': '高雄市杉林區',
  '847': '高雄市甲仙區',
  '848': '高雄市桃源區',
  '849': '高雄市那瑪夏區',
  '851': '高雄市茂林區',
  '852': '高雄市茄萣區',
  // 南海島
  '817': '南海島東沙群島',
  '819': '南海島南沙群島',
  // 澎湖縣
  '880': '澎湖縣馬公市',
  '881': '澎湖縣西嶼鄉',
  '882': '澎湖縣望安鄉',
  '883': '澎湖縣七美鄉',
  '884': '澎湖縣白沙鄉',
  '885': '澎湖縣湖西鄉',
  // 金門縣
  '890': '金門縣金沙鎮',
  '891': '金門縣金湖鎮',
  '892': '金門縣金寧鄉',
  '893': '金門縣金城鎮',
  '894': '金門縣烈嶼鄉',
  '896': '金門縣烏坵鄉',
  // 屏東縣
  '900': '屏東縣屏東市',
  '901': '屏東縣三地門鄉',
  '902': '屏東縣霧臺鄉',
  '903': '屏東縣瑪家鄉',
  '904': '屏東縣九如鄉',
  '905': '屏東縣里港鄉',
  '906': '屏東縣高樹鄉',
  '907': '屏東縣鹽埔鄉',
  '908': '屏東縣長治鄉',
  '909': '屏東縣麟洛鄉',
  '911': '屏東縣竹田鄉',
  '912': '屏東縣內埔鄉',
  '913': '屏東縣萬丹鄉',
  '920': '屏東縣潮州鎮',
  '921': '屏東縣泰武鄉',
  '922': '屏東縣來義鄉',
  '923': '屏東縣萬巒鄉',
  '924': '屏東縣崁頂鄉',
  '925': '屏東縣新埤鄉',
  '926': '屏東縣南州鄉',
  '927': '屏東縣林邊鄉',
  '928': '屏東縣東港鎮',
  '929': '屏東縣琉球鄉',
  '931': '屏東縣佳冬鄉',
  '932': '屏東縣新園鄉',
  '940': '屏東縣枋寮鄉',
  '941': '屏東縣枋山鄉',
  '942': '屏東縣春日鄉',
  '943': '屏東縣獅子鄉',
  '944': '屏東縣車城鄉',
  '945': '屏東縣牡丹鄉',
  '946': '屏東縣恆春鎮',
  '947': '屏東縣滿州鄉',
  // 臺東縣
  '950': '臺東縣臺東市',
  '951': '臺東縣綠島鄉',
  '952': '臺東縣蘭嶼鄉',
  '953': '臺東縣延平鄉',
  '954': '臺東縣卑南鄉',
  '955': '臺東縣鹿野鄉',
  '956': '臺東縣關山鎮',
  '957': '臺東縣海端鄉',
  '958': '臺東縣池上鄉',
  '959': '臺東縣東河鄉',
  '961': '臺東縣成功鎮',
  '962': '臺東縣長濱鄉',
  '963': '臺東縣太麻里鄉',
  '964': '臺東縣金峰鄉',
  '965': '臺東縣大武鄉',
  '966': '臺東縣達仁鄉',
  // 花蓮縣
  '970': '花蓮縣花蓮市',
  '971': '花蓮縣新城鄉',
  '972': '花蓮縣秀林鄉',
  '973': '花蓮縣吉安鄉',
  '974': '花蓮縣壽豐鄉',
  '975': '花蓮縣鳳林鎮',
  '976': '花蓮縣光復鄉',
  '977': '花蓮縣豐濱鄉',
  '978': '花蓮縣瑞穗鄉',
  '979': '花蓮縣萬榮鄉',
  '981': '花蓮縣玉里鎮',
  '982': '花蓮縣卓溪鄉',
  '983': '花蓮縣富里鄉',
};

/// Map three-digit zip code to districts in Taiwan
/// [toDistrict] returns the district based on zip code
/// [toZip] returns the zip code based on district name
class TaiwanZip {
  /// Get all the zip codes
  List<String> get zipCodes => mapping.keys.toList();

  /// Get all the cities
  List<String> get cities =>
      mapping.values.map((value) => value.substring(0, 3)).toSet().toList();

  /// Return the corresponding district based on zip code
  static String toDistrict(String zipCode) {
    if (mapping.containsKey(zipCode)) {
      return mapping[zipCode]!;
    }
    throw Exception('Unable to find district for $zipCode');
  }

  /// Return the corresponding zip code based on the name of district
  static String toZip(String district) {
    // hint the format
    if (district.length < 5) {
      throw Exception('Use city prefix, e.g., 臺北市中正區');
    }
    for (var entry in mapping.entries) {
      if (entry.value == district) {
        return entry.key;
      }
    }
    throw Exception('Unable to find zip for $district');
  }

  /// Get possible districts based on a city
  static List<String> getDistricts(String city, {bool withCity = false}) {
    List<String> districts;
    // hint the format
    if (city.contains('台')) {
      throw Exception('Use 臺 instead of 台');
    }

    var filteredDistricts =
        mapping.values.where((value) => value.contains(city));
    if (filteredDistricts.isEmpty) {
      throw Exception('Unable to find districts for $city');
    }

    if (withCity) {
      districts = filteredDistricts.toList();
    } else {
      districts = filteredDistricts
          .map((value) => value.substring(3, value.length))
          .toList();
    }

    return districts;
  }
}
